/**
  *  \file client/scr-sim.h
  */
#ifndef PCC_V2_CLIENT_SCR_SIM_H
#define PCC_V2_CLIENT_SCR_SIM_H

#include "game/sim-if.h"
#include "ui/window.h"

class WSimScreen : public UIWindow {
    ObjectHolder h;

    UIGroup control_group;
    ObjectHolder holder;
 public:
    WSimScreen();
    ~WSimScreen();

    void editPlanet();
    void editOptions();
    void loadFile();
    void saveFile();
    void runSimulation();
    void writeToGame();
    void updateFromGame();
    bool handleEvent(const UIEvent& event, bool second_pass);

    static GSimState sim_state;
    static GSimOptions sim_opts;

    static bool isExpGame();
};

int doSimulator(GSimulatorGameInterface& game_iface);

#endif
