/**
  *  \file int/fun-tbl.h
  *  \brief Function Tables
  *
  *  (c) 2001-2006 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#ifndef PCC_V2_INT_FUN_TBL_H
#define PCC_V2_INT_FUN_TBL_H

#include "int/data.h"

typedef IntObject (*IntGenericFunctionPtr)();
typedef IntObject (*IntFunction1Ptr)(IntObject);
typedef IntObject (*IntFunction2Ptr)(IntObject,IntObject);
typedef IntObject (*IntFunction3Ptr)(IntObject,IntObject,IntObject);

#if 0
class IntBasicFunctionRegistry {
    IntGenericFunctionPtr* data;
    size_t count, alloc;
 protected:
    IntGenericFunctionPtr get(handle_t h) { return data[h]; }
    handle_t put(IntGenericFunctionPtr p);
 public:
    IntBasicFunctionRegistry();
    ~IntBasicFunctionRegistry();

    typedef unsigned int handle_t;
};

template<typename T>
class IntFunctionRegistry : public IntBasicFunctionRegistry {
 public:
    T get(handle_t h) { return (T) IntBasicFunctionRegistry::get(h); }
    handle_t put(T p) { return IntBasicFunctionRegistry::put(IntGenericFunctionPtr(p)); }
};

IntFunctionRegistry<IntUnaryFunction>   unary_functions;
IntFunctionRegistry<IntBinaryFunction>  binary_functions;
IntFunctionRegistry<IntTernaryFunction> ternary_functions;
#endif

extern IntFunction1Ptr unary_table[];

enum IntUnaryFunction {
    FX_Not,
    FX_Bool,
    FX_Negate,
    FX_Abs,
    FX_Int,
    FX_Round,
    FX_Sqrt,
    FX_Zap,
    FX_Chr,
    FX_Asc,
    FX_Cos,
    FX_Sin,
    FX_Tan,
    FX_MakeFD,
    FX_IsEmpty
};

extern IntFunction2Ptr binary_table[];

enum IntBinaryFunction {
    FX_Sequence,
    FX_LT,
    FX_GT,
    FX_LE,
    FX_GE,
    FX_EQ,
    FX_NE,
    FX_Plus,
    FX_Minus,
    FX_Mul,
    FX_Div,
    FX_Mod,
    FX_RealDiv,
    FX_Concat,
    FX_Hash,
    FX_Pow,
    FX_PartialAnd,
    FX_PartialOr,
    FX_PartialXor
};

extern IntFunction3Ptr ternary_table [];

enum IntTernaryFunction { FX_Dummy3 };

#endif
