/**
  *  \file int/if-arrays.cc
  *
  *  (c) 2001-2006 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "int/if-arrays.h"
#include "game/global.h"
#include "int/if-planet.h"
#include "game/planet.h"

/***************************** IntPlanetArray ****************************/

IntPlanetArray::IntPlanetArray()
{ }

IntPlanetArray::~IntPlanetArray()
{ }

int
IntPlanetArray::getMinIndex()
{
    return 1;
}

int
IntPlanetArray::getMaxIndex()
{
    return NUM_PLANETS;
}

Ptr<IntContext>
IntPlanetArray::getFirst()
{
    int i = 0;
    do
        ++i;
    while (i <= NUM_PLANETS && !getCurrentTurn().getPlanet(i).isExistant());
    if (i <= NUM_PLANETS)
        return new IntPlanetInterface(i);
    else
        return 0;
}

Ptr<IntContext>
IntPlanetArray::getObjectByIndex(int32 index)
{
    if (index > 0 && index <= NUM_PLANETS && getCurrentTurn().getPlanet(index).isExistant())
        return new IntPlanetInterface(index);
    else
        return 0;
}
